package dungeonsofdestiny.game.tiles
{
    import dungeonsofdestiny.game.RoomTile;
    import dungeonsofdestiny.game.Room;
    import loom2d.ui.TextureAtlasManager;
    import loom2d.display.DisplayObjectContainer;
    import loom2d.animation.Juggler;

    import types.TileEffect_t;

    class DoorDest extends RoomTile
    {
        public function DoorDest(juggler: Juggler, room: Room)
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "door_shut"));
            effect += TileEffect_t.WIN; //Win gets processed first
            effect += TileEffect_t.BLOCK;
        }
    }

    class DoorSrc extends RoomTile
    {
        public function DoorSrc(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "door_src"));
            effect += TileEffect_t.BLOCK;
        }
    }
    class BorderC extends RoomTile
    {
        public function BorderC(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "border_c"));
            effect += TileEffect_t.BLOCK;
        }
    }
    class BorderNW extends RoomTile
    {
        public function BorderNW(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "border_nw"));
            effect += TileEffect_t.BLOCK;
        }
    }
    class BorderN extends RoomTile
    {
        public function BorderN(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "border_n"));
            effect += TileEffect_t.BLOCK;
        }
    }
    class BorderNE extends RoomTile
    {
        public function BorderNE(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "border_ne"));
            effect += TileEffect_t.BLOCK;
        }
    }
    class BorderW extends RoomTile
    {
        public function BorderW(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "border_w"));
            effect += TileEffect_t.BLOCK;
        }
    }
    class BorderE extends RoomTile
    {
        public function BorderE(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "border_e"));
            effect += TileEffect_t.BLOCK;
        }
    }
    class BorderSW extends RoomTile
    {
        public function BorderSW(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "border_sw"));
            effect += TileEffect_t.BLOCK;
        }
    }
    class BorderS extends RoomTile
    {
        public function BorderS(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "border_s"));
            effect += TileEffect_t.BLOCK;
        }
    }
    class BorderSE extends RoomTile
    {
        public function BorderSE(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "border_se"));
            effect += TileEffect_t.BLOCK;
        }
    }

    class Hole extends RoomTile
    {
        public function Hole(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "hole"));
            effect += TileEffect_t.BLOCK;
            effect += TileEffect_t.DAMAGE;
        }
    }


    class Ground extends RoomTile
    {
        public function Ground(juggler: Juggler, room: Room)
        
        {
            super(juggler, room);
            set_texture(TextureAtlasManager.getTexture("tiles", "ground1"));
        }
    }

    class IceRune extends RoomTile
    {
        public function IceRune(juggler: Juggler, room: Room)
        
        {
            super(juggler, room); 
            set_texture(TextureAtlasManager.getTexture("tiles", "icetile"));
        }
    }

    class PushBlock extends RoomTile
    {
        public function PushBlock(juggler: Juggler, room: Room)
        {
            super(juggler, room); 
            set_texture(TextureAtlasManager.getTexture("tiles", "pushblock1"));
        }
    }
}
