package types
{
    //Used by the View and relayout system
    public enum Orientation_t
    {
        HORIZONTAL = 1,
        VERTICAL,
    }
    
    public enum Edge_t
    {
        TOP = 1,
        BOTTOM,
        LEFT,
        RIGHT,
    }

    public class TileEffect_t
    {
        public static var DAMAGE: int = 1;
        public static var BLOCK: int = 2;
        public static var INTERACT: int = 4;
        public static var FALL: int = 8;
        public static var WIN: int = 16;

        public static function has_effect(test: int, effect: int): Boolean
        {
            if (test & effect)
                return true;
            else
                return false;
        }
    }



}
